; blok stejnych znaku
DBLOK	MACRO	ZNAK, POCET
	IF POCET>=1
	DATA	(ZNAK % D'256')
	ENDIF
	IF POCET>=2
	DATA	((POCET-1) % D'256') + H'0300'
	ENDIF
	ENDM

; pozice na displeji
POS_D	MACRO	POZICE
	DATA	(POZICE % D'128') + H'0180'
	ENDM

; pozice v pameti uzivatelskych znaku
POS_SG	MACRO	POZICE
	DATA	(POZICE % D'64') + H'0140'
	ENDM

; obecny prikaz
DCOMMAND	MACRO	KOD
	DATA	(KOD % D'256') + H'0100'
	ENDM

; zobrazi ciselnou hodnotu ulozenou na adrese "ADRESA"
PRINTV	MACRO	ADRESA, FORMAT, V16, OBRACENE, NULY, ODSAZENI
	DATA	D'8192' + D'4096' + (FORMAT % D'32') + (D'32'*(V16%D'2')) + (D'64'*((ODSAZENI+1)%D'2')) + (D'128'*((NULY+1)%2))
	DATA	D'8192' + (ADRESA % D'512') + (D'512'*(V16%D'2')) + (D'1024'*(OBRACENE%D'2'))
	ENDM

; resetuje displej
DRESET	MACRO
	DATA	D'1' + H'0100'
	ENDM

; nastavi pocatecni pozici
DHOME	MACRO
	DATA	D'2' + H'0100'
	ENDM

; ukonceni skriptu
EOFS	MACRO
	DATA	H'0200'
	ENDM


; provadi skripty
;  TABADR - adresa indexacni tabulky
;  WRITE - adresa podprogramu, ktery vypise znak na displej (kod znaku se predava pomoci W)
;  DPRIKAZ - adresa podprogramu, ktery posle radici displeje jednobytovy prikaz (vstupem je W)
;  XTEMP - pomocna promena
;  DIV16 - adresa podprogramu, ktery zprostredkovava 16bitove deleni
;  AA,BB,CC - 16bitove promenne, pouzivane pri deleni

SKRIPT_	MACRO	TABADR, _WRITE, DPRIKAZ, XTEMP, DIV16, AA, BB, CC

	LOCAL	KONEC, LOOP, CISLA, PRIKAZ, SIMPLE, OBRACENE
	LOCAL	NPRINT, DZNAK

	TABFIND	TABADR	; je vybran spravny skript
LOOP	NEXTREAD		; je precten nasledujici prikaz skriptu
	banksel	EEDATH
	BTFSC	EEDATH,5
	GOTO	CISLA	; byl rozpoznan nektery prikaz pro zobrazeni cisla
	MOVF	EEDATH,F
	BTFSC	STATUS,Z
	GOTO	DZNAK	; byl rozpoznan prikaz pro jednoduche vypsani znaku
	DECF	EEDATH,F
	BTFSC	STATUS,Z
	GOTO	PRIKAZ	; byl rozpoznan prikaz pro radic displeje
	DECF	EEDATH,F
	BTFSC	STATUS,Z
	GOTO	KONEC	; byl rozpoznan konec skriptu
OPAKUJ	; zbyva prikaz pro vypsani bloku stwejnych znaku
	banksel	XTEMP
	MOVF	XTEMP,W	; precte posledni znak
	CALL	_WRITE	; a vypise jej
	banksel	EEDATA
	DECFSZ	EEDATA,F	; snizi pocet opakovani o jednicku
	GOTO	OPAKUJ	; pokud je vysledek nenulovy, vse se opakuje
	GOTO	LOOP	; konec prikazu
DZNAK	MOVF	EEDATA,W	; nacte znak
	banksel	XTEMP
	MOVWF	XTEMP	; ulozi jej do XTEMP
	banksel	0
	CALL	_WRITE	; a vypise jej
	GOTO	LOOP
PRIKAZ	MOVF	EEDATA,W	; nacte prikaz
	banksel	0
	CALL	DPRIKAZ	; a provede jej
	GOTO	LOOP

; zde se zpracovavaji ciselne hodnoty
CISLA	BTFSC	EEDATH,4
	GOTO	SETFORMAT	; rozpoznan prikaz k nastaveni formatu
	BCF	STATUS,IRP
	BTFSC	EEDATH,0
	BSF	STATUS,IRP; byl nastaven nejvyssi bit adresy promenne
	MOVF	EEDATA,W
	MOVWF	FSR	; byla jiz nastavena cela adresa
	BTFSS	EEDATH,1
	GOTO	SIMPLE	; promena je 8bitova
	BTFSC	EEDATH,2
	GOTO	OBRACENE	; promena je 16bitova, ale v obracenem poradi bytu
	banksel	AA	; promena je 16bitova ve zakladnim poradi bytu
	MOVF	INDF,W	; precten nizsi byte
	MOVWF	AA
	INCF	FSR,F
	MOVF	INDF,W	; precten vyssi byte
	MOVWF	AA + 1
	GOTO	NPRINT	; promenna se vypise na displej
OBRACENE	
	banksel	AA
	MOVF	INDF,W	; precten vyssi byte
	MOVWF	AA + 1
	INCF	FSR,F
	MOVF	INDF,W	; precten nizzsi byte
	MOVWF	AA
	GOTO	NPRINT	; vypsani na displej
SIMPLE	
	banksel	AA
	MOVF	INDF,W	; nacte se nizsi byte
	MOVWF	AA
	CLRF	AA + 1	; vyssi byte je nulovy
	GOTO	NPRINT	; vypsani na displej

NULA	MOVF	XTEMP,W
	ANDLW	B'11100000' ; pokud je poprve aktivni odsazovani bez nul,
	XORLW	B'10000000'
	BTFSS	STATUS,Z
	GOTO	NULA_
	BSF	XTEMP,5	; potom nic nevypisujeme, ale nastavime XTEMP,5
	RETURN
NULA_	BTFSC	XTEMP,6	; v opacnem pripade vypiseme:
	RETURN		; ...nic!
	MOVLW	'0'	; ...nulu
	BTFSC	XTEMP,7
	MOVLW	' '	; ...nebo mezeru
	CALL	_WRITE
	RETURN

CISLICE	MOVF	XTEMP,W
	ANDLW	B'11100000'
	XORLW	B'10100000'
	BTFSS	STATUS,Z	; pokud je aktivni odsazovani bez nul, ale nikoliv poprve
	GOTO	CISLICE_
	MOVLW	' '	; ...potom nejprve vypiseme mezeru
	CALL	_WRITE
CISLICE_	MOVF	CC,W	; pote vypiseme cislici
	ADDLW	'0'
	CALL	_WRITE
	BCF	XTEMP,7	; ...a zrusime "odsazovaci" i "nulove" nastaveni
	BCF	XTEMP,6
	RETURN

NPRINT	BCF	XTEMP,5	; vymazani "smeti"
	banksel	BB
	MOVLW	D'10000' % D'256'
	MOVWF	BB
	MOVLW	D'10000' / D'256'
	MOVWF	BB + 1	; v BB je prvni delitel
	CALL	DIV16
	BTFSS	XTEMP,4	; ma se cislice vypisovat?
	GOTO	NUM4
	MOVF	CC,F	; pokud je cislice nula,...
	BTFSC	STATUS,Z
	CALL	NULA	; ...spusti se specialni podprogram
	MOVF	CC,F
	BTFSS	STATUS,Z	; pokud je cislice nenulova,...
	CALL	CISLICE	; ...spusti se jiny podprogram

	;totez se opakuje i pro dalsi cislice...

NUM4	MOVLW	D'1000' % D'256'
	MOVWF	BB
	MOVLW	D'1000' / D'256'
	MOVWF	BB + 1
	CALL	DIV16
	BTFSS	XTEMP,3
	GOTO	NUM3
	MOVF	CC,F
	BTFSC	STATUS,Z
	CALL	NULA
	MOVF	CC,F
	BTFSS	STATUS,Z
	CALL	CISLICE

NUM3	MOVLW	D'100'
	MOVWF	BB
	CLRF	BB + 1
	CALL	DIV16
	BTFSS	XTEMP,2
	GOTO	NUM2
	MOVF	CC,F
	BTFSC	STATUS,Z
	CALL	NULA
	MOVF	CC,F
	BTFSS	STATUS,Z
	CALL	CISLICE

NUM2	MOVLW	D'10'
	MOVWF	BB
	CLRF	BB + 1
	CALL	DIV16
	BTFSS	XTEMP,1
	GOTO	NUM1
	MOVF	CC,F
	BTFSC	STATUS,Z
	CALL	NULA
	MOVF	CC,F
	BTFSS	STATUS,Z
	CALL	CISLICE

NUM1	BTFSS	XTEMP,0
	GOTO	NUM0
	MOVF	AA,W
	MOVWF	CC
	BTFSC	STATUS,Z
	CALL	NULA
	MOVF	CC,F
	BTFSS	STATUS,Z
	CALL	CISLICE

NUM0	MOVF	XTEMP,W
	ANDLW	B'11000000' ; pokud nebyla vypsana zadna cislice,
	MOVLW	'0'
	BTFSS	STATUS,Z
	CALL	_WRITE	; ...potom vypiseme nulu
	
	GOTO	LOOP	; konec prikazu
	
; nastaveni formatu
SETFORMAT	MOVF	EEDATA,W	; precte se format
	banksel	XTEMP	; ...a ulozi se do XTEMP
	MOVWF	XTEMP
	GOTO	LOOP
	
KONEC
	banksel	0

	ENDM
