;-------------------------------------------------;
; CASOVANI POMOCI TMR2 S PERIODOU 100 STROJ.CYKLU ;
;        - neni pouzita presna kalibrace          ;
;         !!! NUTNO POUZIT DISPLEJ !!!            ;
;-------------------------------------------------;


	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'


	#include	displej.inc
	#include	tab_util.inc
	#include	dskripty.inc
	#include	div16u.inc

;---------------------------------------------
; KONSTANTY PROGRAMU

STRFREK	EQU	D'50000'	; FREKVENCE KRYSTALU / 400

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

	CBLOCK	OFFRAM
	TML:1
	TMH:1
	DDATA:1

	CLOCK:2	; pro mereni casu
	TIK:1
	SEC:1
	MIN:1
	HOD:1

	AA:2	; pro skripty
	BB:2
	CC:2
	VD16U:1
	NUMFORM_:1
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	ENDC

;------------------------------------------------------
; RESET / START
	
	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	GOTO	START

;------------------------------------------------------
; OBSLUHA PRERUSENI

	ORG	4
	MOVWF	W_TEMP		; zaloha registru W a STATUS
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	banksel	0
	BCF	PIR1,TMR2IF	; odstraneni priznaku
	DECFSZ	CLOCK+0,F		; postupna dekrementace 16bitove promenne CLOCK
	GOTO	INT_END
	DECFSZ	CLOCK+1,F
	GOTO	INT_END
	MOVLW	(STRFREK-1) % H'100' + 1	; po nabyti nuly se musi CLOCK...
	MOVWF	CLOCK + 0			; opet nalezite nastavit
	MOVLW	(STRFREK-1) / H'100' + 1
	MOVWF	CLOCK + 1
	INCF	TIK,F		; ubehla dalsi sekunda
INT_END	MOVF	ST_TEMP,W		; obnova registru ze zalohy
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

;-------------------------------------------------
; INICIALIZACE
	
START	
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1
	banksel	0
	
	banksel	OPTION_REG
	MOVLW	B'00001000'
	MOVWF	OPTION_REG
	banksel	T2CON		; nastaveni casovace TMR2
	MOVLW	B'00000100'
	MOVWF	T2CON
	banksel	PR2
	MOVLW	D'99'
	MOVWF	PR2
	banksel	TMR2
	CLRF	TMR2
	BCF	PIR1,TMR2IF

	; inicializace displeje
	CALL	INITDISP

	MOVLW	(STRFREK-1) % H'100' + 1	; pocatecni nastaveni promennych
	MOVWF	CLOCK + 0
	MOVLW	(STRFREK-1) / H'100' + 1
	MOVWF	CLOCK + 1
	CLRF	TIK
	CLRF	SEC
	CLRF	MIN
	CLRF	HOD

	banksel	PIE1
	BSF	PIE1,TMR2IE	; povoleno preruseni od TMR2
	banksel	0
	BSF	INTCON,PEIE	; povoleno preruseni od priznaku v PIR1 a PIR2
	BSF	INTCON,GIE	; aktivace systemu preruseni

;----------------------------------------------------
; HLAVNI PROGRAM
	MOVLW	D'0'
	CALL	SKRIPT
LOOP	MOVF	TIK,W	; testujeme, zda doslo ke zvyseni citace sekund
	BTFSC	STATUS,Z
	GOTO	LOOP
	DECF	TIK,F	; pokud ano snizime citac sekund a...
	CALL	INC_TIME	; ...inkrementujeme casomiru
	MOVLW	D'0'	; zobrazime cas na displeji
	CALL	SKRIPT
	GOTO	LOOP

INC_TIME	INCF	SEC,F	; zvysime sekundovou cislici
	MOVF	SEC,W
	XORLW	D'60'
	BTFSS	STATUS,Z	; pokud dosahne hodnoty 60,...
	RETURN
	CLRF	SEC	; ...vynulujeme ji a....
	INCF	MIN,F	; ...zvysime cislici minut
	MOVF	MIN,W
	XORLW	D'60'
	BTFSS	STATUS,Z	; obdobne to vyresime i pro cislici hodin
	RETURN
	CLRF	MIN
	INCF	HOD,F
	MOVF	HOD,W
	XORLW	D'24'
	BTFSS	STATUS,Z
	RETURN
	CLRF	HOD
	RETURN

;-----------------------------------------------------------
; deleni	
DIV16U	DIV16U_M	AA,BB,CC,VD16U 

;zobrazovaci skripty
SKRIPT	SKRIPT_	TABULKY, PUTZNAK, DPRIKAZ, NUMFORM_, DIV16U, AA, BB, CC
	RETURN

; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS
;-----------------------------------------------------------
TABULKY	DATA	VYPIS_CLK

; vypise na displeji napis "CASOMIRA (3)" a...
; ...cas ve formatu HH:MM:SS
VYPIS_CLK	POS_D	D'0'
	DE	"  CASOMIRA (3)  "
	POS_D	D'64'
	DE	"    "
	PRINTV	HOD,B'00011',0,0,1,1
	DE	":"
	PRINTV	MIN,B'00011',0,0,1,1
	DE	":"
	PRINTV	SEC,B'00011',0,0,1,1
	DE	"    "
	EOFS


	END
